﻿namespace Excercise01
{
    internal class GameOfLife
    {
        /// <summary> Grid with cells that will be used for the simulation </summary>
        public LifeCell[,] cells;
        /// <summary> Number of rows </summary>
        int m; 
        /// <summary> Number of columns </summary>
        int n;

        /// <summary>
        /// Generate the starting configuration
        /// </summary>
        /// <param name="m"> Number of rows </param>
        /// <param name="n"> Number of columns </param>
        internal void GenerateRandLife(int m, int n)
        {
            this.m = m; this.n = n;

            cells = new LifeCell[m, n];
            for (int i = 0; i < cells.GetLength(0); i++)
            {
                for (int j = 0; j < cells.GetLength(1); j++)
                {
                    cells[i, j] = new LifeCell(i, j);

                }
            }

            // TODO implement random initialization of all cells

            // this is a simple glider
            cells[0, 1].alive = true;
            cells[1, 2].alive = true;
            cells[2, 0].alive = true;
            cells[2, 1].alive = true;
            cells[2, 2].alive = true;
        }

        /// <summary>
        /// Method for the simulation of Conway's game of life 
        /// - apply the rules on all of the cells of the current configuration
        /// - create a new configuration that can be visualized
        /// </summary>
        internal void NextStep()
        {
            // TODO implement

            throw new NotImplementedException("Simulation not implemented yet");
        }

    }
}